/*
 * Renderer.h
 *
 * Copyright (C) 2009 Matthias Schiffer <matthias@gamezock.de>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOM_RENDERER_H_
#define ZOOM_RENDERER_H_

#include "gl.h"

#include "Shader.h"
#include "ShadowVolume.h"
#include "TriangleRecord.h"

#include <limits>


namespace Zoom {

class Renderer {
  public:
    Renderer();

    //void render(const BSPTree &tree);

    template <typename T>
    void render(const T &triangles, const vmml::vec3f &lightPos) {
      if(triangles.empty())
        return;

      // Create shadow volumes
      std::vector<ShadowVolume> shadowVolumes;
      for(typename T::const_iterator t = triangles.begin(); t != triangles.end(); ++t) {
        shadowVolumes.push_back(ShadowVolume(t->getTriangle(), lightPos));
      }


      glLightfv(GL_LIGHT0, GL_POSITION, vmml::vec4f(lightPos, 1).array);

      // Render with ambient light
      Shader::enable(ambientShader);
      glBlendFunc(GL_ONE, GL_ZERO);
      glDepthFunc(GL_LEQUAL);
      glStencilFunc(GL_ALWAYS, 0, std::numeric_limits<GLuint>::max());
      glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);

      useTexture(triangles.front().getTriangle().getTexture());

      glBegin(GL_TRIANGLES);
      for(typename T::const_iterator t = triangles.begin(); t != triangles.end(); ++t) {
        renderTriangle(t->getTriangle());
      }
      glEnd();

      // Render shadow volumes
      Shader::enable(nullShader);
      glClear(GL_STENCIL_BUFFER_BIT);
      glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
      glDepthMask(GL_FALSE);

      glCullFace(GL_FRONT);
      glDepthFunc(GL_GEQUAL);
      glStencilOp(GL_KEEP, GL_KEEP, GL_INCR);

      glBegin(GL_TRIANGLES);
      for(std::vector<ShadowVolume>::iterator v = shadowVolumes.begin(); v != shadowVolumes.end(); ++v) {
        renderShadowVolume(*v);
      }
      glEnd();

      glCullFace(GL_BACK);
      glStencilOp(GL_KEEP, GL_KEEP, GL_DECR);

      glBegin(GL_TRIANGLES);
      for(std::vector<ShadowVolume>::iterator v = shadowVolumes.begin(); v != shadowVolumes.end(); ++v) {
        renderShadowVolume(*v);
      }
      glEnd();

      glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
      glDepthMask(GL_TRUE);

      // Render with point light
      Shader::enable(lightShader);
      glBlendFunc(GL_ONE, GL_ONE);
      glDepthFunc(GL_EQUAL);
      glStencilFunc(GL_EQUAL, 0, std::numeric_limits<GLuint>::max());
      glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);

      useTexture(triangles.front().getTriangle().getTexture());

      glBegin(GL_TRIANGLES);
      for(typename T::const_iterator t = triangles.begin(); t != triangles.end(); ++t) {
        renderTriangle(t->getTriangle());
      }
      glEnd();
    }

    struct TextureSorter {
      bool operator() (const TriangleRecord &t1, const TriangleRecord &t2) {
        return (t1.getTriangle().getTexture() < t2.getTriangle().getTexture());
      }
    };

  private:
    void renderTriangle(const Triangle &t);
    static void renderShadowVolume(const ShadowVolume &v);
    void useTexture(unsigned texture);

    class RenderVisitor {
      public:
        RenderVisitor(Renderer *renderer0) : renderer(renderer0) {}

        void operator() (const TriangleRecord &t) const {
          renderer->renderTriangle(t.getTriangle());
        }

      private:
        Renderer *renderer;
    };

    boost::shared_ptr<Shader> nullShader, ambientShader, lightShader;
    unsigned activeTexture;

    const RenderVisitor renderVisitor;
};

}

#endif /* ZOOM_RENDERER_H_ */
